﻿#include "4-Digit-Schiebe.h"
#include <avr/io.h>
#include <util/delay.h>

int digit_init(void)
{
	Digit_DDR &= ~( (1<<digit1) | (1<<digit2) | (1<<digit3) | (1<<digit4) );
	Digit_Schiebe_DDR &= ~( (1<<clock_digit) | (1<<data_digit) | (1<<strobe_digit) );
	
	return 0;
}



int digit_out(unsigned char digit_data[4])  // Digit-Ansteuerung
{
	unsigned char bits,i;
	
	for (i=4;i>0;i--)
	{
		switch(i) // Passendes Digit einschalten
		{
			case 1: Digit_Port &=~ ((0<<digit1));
					break;
					
			case 2: Digit_Port &=~ ((0<<digit2));
					break;
					
			case 3: Digit_Port &=~ ((0<<digit3));
					break;
					
			case 4: Digit_Port &=~ ((0<<digit4));
					break;
		}
		
		for (bits = 8; bits > 0; bits--)
			{
				Digit_Schiebe_Port &=~ ((0<<data_digit));
				if (digit_data[i] & 0x80)
				{
					Digit_Schiebe_Port &=~ ((1<<data_digit));
				}

				digit_data[i] <<= 1;
			
				Digit_Schiebe_Port &=~ ((0<<clock_digit));
				Digit_Schiebe_Port &=~ ((1<<clock_digit));
			}
			
		_delay_ms(digit_delay);
		
		Digit_Schiebe_Port &=~ ((0<<digit1)); // Alle Digits abschalten
		Digit_Schiebe_Port &=~ ((0<<digit2));
		Digit_Schiebe_Port &=~ ((0<<digit3));
		Digit_Schiebe_Port &=~ ((0<<digit4));
	}			
		
	return 0;
}
